/*!
 * bootstrap-for-vue v0.1.2
 * (c) 2017 Rahul Kadyan
 * Released under the MIT License.
 */
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('sifter'), require('lodash.debounce')) :
	typeof define === 'function' && define.amd ? define(['exports', 'sifter', 'lodash.debounce'], factory) :
	(factory((global['bootstrap-for-vue'] = global['bootstrap-for-vue'] || {}),global.Sifter,global.debounce));
}(this, (function (exports,Sifter,debounce) { 'use strict';

Sifter = 'default' in Sifter ? Sifter['default'] : Sifter;
debounce = 'default' in debounce ? debounce['default'] : debounce;

var Alert = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return (_vm.inDOM)?_c('div',{staticClass:"alert",class:[("alert-" + (_vm.type))],attrs:{"role":"alert"}},[(_vm.dismissable)?_c('button',{staticClass:"close",attrs:{"type":"button","aria-label":"Close"},on:{"click":_vm.dismiss}},[_c('span',{attrs:{"aria-hidden":"true"}},[_vm._v("×")])]):_vm._e(),_vm._t("default",[_vm._v(_vm._s(_vm.message))])],2):_vm._e()},staticRenderFns: [],
  name: 'Alert',

  props: {
    message: {
      type: String
    },

    type: {
      type: String,
      default: 'success'
    },

    dismissable: {
      type: Boolean,
      default: true
    },

    removeFromDOM: {
      type: Boolean,
      default: true
    }
  },

  data: function data () {
    return {
      inDOM: true
    }
  },

  methods: {
    /**
     * Dismiss alert.
     *
     * @return {undefined}
     */
    dismiss: function dismiss () {
      this.$emit('dismiss');

      if (this.removeFromDOM) {
        this.inDOM = false;
      }
    }
  }
};

var Breadcrumb = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('nav',{staticClass:"breadcrumb"},_vm._l((_vm.crumbs),function(crumb){return _c(_vm.component,{tag:"div",staticClass:"breadcrumb-item",attrs:{"to":crumb.link,"active-class":"active"}},[_vm._v(_vm._s(crumb.title))])}))},staticRenderFns: [],
  props: {
    links: {
      type: Array,
      required: true
    },

    component: {
      type: String,
      default: 'router-link'
    }
  },

  computed: {
    crumbs: function crumbs () {
      var links = this.links;

      if (typeof (links[0]) === 'string') {
        return links.map(function (link) { return ({ link: link, title: link }); })
      }

      return links
    }
  }
};

var CheckboxWrapper = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('fieldset',{staticClass:"form-group"},[(_vm.title)?_c('legend',{staticClass:"wrapper-legend"},[_vm._v(_vm._s(_vm.title))]):_vm._e(),_vm._t("default")],2)},staticRenderFns: [],
  name: 'InputWrapper',

  props: {
    title: {
      type: String,
      default: null
    }
  }
};

var Dropdown = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{class:[("drop" + (_vm.type)), (_vm.show ? 'show' : '')]},[_vm._t("default",[(_vm.items.length)?_c('div',{staticClass:"dropdown-menu"},_vm._l((_vm.items),function(item){return _c(_vm.component,{key:item,tag:"div",staticClass:"dropdown-item",attrs:{"item":item},on:{"click":function($event){$event.preventDefault();_vm.$emit('select', item);}}},[_vm._v(_vm._s(item[_vm.itemKey]))])})):_c('div',{staticClass:"dropdown-menu"},[_vm._t("empty")],2)])],2)},staticRenderFns: [],
  props: {
    show: {
      type: Boolean,
      required: true
    },

    type: {
      validator: function validator (type) {
        return ['up', 'down'].indexOf(type) > -1
      },
      default: 'down'
    },

    items: {
      type: Array,
      required: true
    },

    itemKey: {
      type: String,
      default: 'name'
    },

    component: {
      type: String,
      default: 'a'
    }
  }
};

var Icon = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('i',{staticClass:"fa",class:[("fa-" + (_vm.type))]})},staticRenderFns: [],
  name: 'Icon',
  
  props: {
    type: {
      required: true,
      type: String
    }
  }
};

function isArray (any) {
  return typeof (any) === 'object' && any instanceof Array
}

function isObject (any) {
  return any !== null && typeof (any) === 'object'
}

function mapObject (source, take) {
  var target = {};

  if (isArray(take)) {
    take.forEach(function (key) {
      if (key in source) {
        target[key] = source[key];
      }
    });
  } else {
    Object.keys(take).forEach(function (sourceKey) {
      var targetKey = take[sourceKey];

      if (sourceKey in source) {
        target[targetKey] = source[sourceKey];
      }
    });
  }

  return target
}

function getDirectiveExpression (vnode, name) {
  if (!vnode || !vnode.data || !(vnode.data.directives instanceof Array)) { return null }

  if (!/^v-.*/.test(name)) { name = "v-" + name; }

  for (var i = 0; i < vnode.data.directives.length; i += 1) {
    var directive = vnode.data.directives[i];

    if (directive.rawName === name) {
      return directive.expression
    }
  }

  return null
}

var getExpression = {
  methods: {
    getExpression: function getExpression (key, type) {
      if ( type === void 0 ) type = 'directive';

      if (!this.$vnode) { return null }

      if (type === 'directive') { return getDirectiveExpression(this.$vnode, key) }

      return null
    }
  }
};

var inputHelper = {
  props: {
    value: { type: [Number, String], required: true },
    title: { type: String, default: null },
    subtitle: { type: String, default: null },
    name: { type: String, default: null },
    errors: {
      validator: function validator (errors) {
        return typeof (errors) === 'object' && typeof (errors.has) === 'function'
      },
      default: null
    }
  },
  data: function data () {
    return {
      expression: null,
      autofocus: null,
      required: null,
      placeholder: null,
      autofill: null
    }
  },
  computed: {
    id: function id () {
      return ("text" + (this._uid))
    },
    nameKey: function nameKey () {
      var name = this.name;
      var expression = this.expression;

      return name || expression
    },
    feedback: function feedback () {
      var errors = this.errors;
      var name = this.nameKey;

      if (errors) {
        return errors.get(name)
      }

      return undefined
    }
  },

  methods: {
    updateAttributes: function updateAttributes () {
      if (!this.$vnode || !this.$vnode.data || !this.$vnode.data.attrs) { return }

      this.autofocus = this.$vnode.data.attrs.hasOwnProperty('autofocus');
      this.required = this.$vnode.data.attrs.hasOwnProperty('required');
      this.placeholder = this.$vnode.data.attrs.placeholder;
      this.autofill = this.$vnode.data.attrs.autofill;
    }
  },

  mounted: function mounted () {
    var model = this.getExpression('model');

    if (model) {
      this.expression = model.split('.').pop();
    }

    this.updateAttributes();
  },

  beforeUpdate: function beforeUpdate () {
    this.updateAttributes();
  },

  mixins: [getExpression]

};

var InputBox = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-check",class:{ 'has-danger': _vm.feedback }},[_c('label',{staticClass:"custom-control",class:[("custom-" + (_vm.type))]},[_c('input',_vm._b({staticClass:"custom-control-input",attrs:{"hidden":""},domProps:{"checked":_vm.state},on:{"change":_vm.onChange}},'input',{ type: _vm.type, required: _vm.required, name: _vm.nameKey })),_vm._v(" "),_c('span',{staticClass:"custom-control-indicator"}),_vm._v(" "),(_vm.title)?_c('span',{staticClass:"custom-control-description"},[_vm._v(_vm._s(_vm.title))]):_vm._e()])])},staticRenderFns: [],
  name: 'InputBox',

  props: {
    value: {
      type: [Array, String, Number, Boolean],
      required: true
    },

    radio: {
      default: undefined
    },

    checkbox: {
      default: true
    }
  },

  computed: {
    /**
     * Type of field (radio/checkbox)
     *
     * @type {String}
     */
    type: function type () {
      var radio = this.radio;

      if (radio !== undefined) { return 'radio' }

      return 'checkbox'
    },

    /**
     * Value of the checkbox (If checked, value of the model would be set to this).
     *
     * @type {number|string|bool}
     */
    localValue: function localValue () {
      var radio = this.radio;
      var checkbox = this.checkbox;

      if (radio !== undefined) { return radio }

      return checkbox
    },

    /**
     * Current state of the box/radio.
     *
     * @type {bool}
     */
    state: function state () {
      var value = this.value;
      var localValue = this.localValue;

      if (isArray(value)) {
        return value.indexOf(localValue) > -1
      }

      return value === localValue
    }
  },

  methods: {
    /**
     * Handle check/uncheck event.
     *
     * @return {void}
     */
    onChange: function onChange () {
      if (this.state) {
        this.uncheck();
      } else {
        this.check();
      }
    },

    /**
     * Mark box/radio as checked.
     *
     * @return {void}
     */
    check: function check () {
      if (this.type === 'checkbox' && isArray(this.value)) {
        var value = this.value.slice(0); // Copy Array.

        value.push(this.localValue);
        this.$emit('input', value);

        return
      }

      this.$emit('input', this.localValue);
    },

    /**
     * Mark box/radio as unchecked.
     */
    uncheck: function uncheck () {
      if (this.type === 'radio') { return }

      if (this.value instanceof Array) {
        var value = this.value.slice(0);

        value.splice(value.indexOf(this.localValue), 1);
        this.$emit('input', value);

        return
      }

      if (this.localValue === true) {
        this.$emit('input', false);

        return
      }

      this.$emit('input', null);
    }
  },

  mixins: [inputHelper]
};

var InputButton = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('button',{staticClass:"btn",class:[_vm.styles],attrs:{"role":"button"}},[(_vm.icon)?_c('icon',{staticClass:"mr-2",attrs:{"type":_vm.icon}},[_vm._t("default",[_vm._v(_vm._s(_vm.value))])],2):_vm._e()],1)},staticRenderFns: [],
  name: 'InputButton',

  props: {
    icon: {
      type: String,
      default: null
    },

    class: {
      type: String,
      default: 'btn-primary'
    },

    value: {
      type: String,
      default: null
    }
  },

  computed: {
    styles: function styles () {
      return this.class
    }
  },

  components: { Icon: Icon }
};

var SearchField = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-control input-search"},[_c('div',{staticClass:"input-search-placeholder"},[(_vm.isEmpty)?_c('span',[_vm._t("default",[_c('icon',{attrs:{"type":"search"}},[_c('input',{staticClass:"input-search-placeholder-proxy",attrs:{"type":"text","readonly":"readonly"},domProps:{"value":_vm.placeholder}})])])],2):_vm._e()]),(!_vm.isEmpty && _vm.hasSuggestion && _vm.show)?_c('input',{staticClass:"input-search-suggestion",attrs:{"type":"text","readonly":"readonly"},domProps:{"value":_vm.suggestion}}):_vm._e(),_vm._v(" "),_c('input',{staticClass:"input-search-field",attrs:{"type":"search"},domProps:{"value":_vm.value},on:{"input":function($event){_vm.$emit('input', $event.target.value);},"focus":_vm.onFocus,"blur":_vm.onBlur}})])},staticRenderFns: [],
  name: 'Search',

  props: {
    suggestion: {
      type: String
    },
    placeholder: {
      type: String,
      default: 'Search...'
    },
    value: {
      type: String,
      required: true
    }
  },

  data: function data () {
    return { show: false }
  },

  computed: {
    /**
     * Whether suggesion is available or not?
     *
     * @type {Boolean}
     */
    hasSuggestion: function hasSuggestion () {
      var suggestion = this.suggestion;

      return typeof (suggestion) === 'string' && suggestion.length > 0
    },

    /**
     * Whether input field is empty or not?
     *
     * @type {Boolean}
     */
    isEmpty: function isEmpty () {
      var value = this.value;

      return typeof (value) === 'string' && value.length === 0
    }
  },

  methods: {
    onBlur: function onBlur (event) {
      this.show = false;

      this.$emit('blur', event);
    },
    onFocus: function onFocus (event) {
      this.show = true;

      this.$emit('focus', event);
    }
  },

  components: { Icon: Icon }
};

var InputSearch = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('search-field',_vm._b({staticClass:"form-control",attrs:{"id":_vm.id},on:{"input":function (val) { return _vm.$emit('input', val); }}},'search-field',{ value: _vm.value, required: _vm.required, autofocus: _vm.autofocus, placeholder: _vm.placeholder, suggestion: _vm.suggestion }),[(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()])],1)},staticRenderFns: [],
  name: 'InputSearch',

  props: {
    suggestion: {
      type: String
    }
  },

  components: { SearchField: SearchField },
  mixins: [inputHelper]
};

var InputSelect = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._v(_vm._s(_vm.title))]):_vm._e(),_c('select',_vm._b({staticClass:"form-control custom-select",on:{"input":function($event){_vm.$emit('input', $event.target.value);}}},'select',{ id: _vm.id, value: _vm.value, required: _vm.required, autofocus: _vm.autofocus, multiple: _vm.multiple }),[(_vm.placeholder)?_c('option',{attrs:{"disabled":"disabled"},domProps:{"selected":_vm.value === '' || _vm.value === null}},[_vm._v(_vm._s(_vm.placeholder))]):_vm._e(),_vm._l((_vm.selectOptions),function(option){return _c('option',{attrs:{"disabled":_vm.getDisabled(option)},domProps:{"value":_vm.getValue(option)}},[_vm._v(_vm._s(_vm.getDisplay(option)))])})],2),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._v(_vm._s(_vm.subtitle))]):_vm._e()])},staticRenderFns: [],
  name: 'InputSelect',

  props: {
    options: {
      type: [Array, Object],
      required: true
    },
    multiple: {
      type: [Boolean, Number],
      default: false
    },
    valueKey: {
      type: String,
      default: 'id'
    },
    displayKey: {
      type: String,
      default: 'name'
    },
    disabledKey: {
      type: String,
      default: 'disabled'
    }
  },

  computed: {
    selectOptions: function selectOptions () {
      var this$1 = this;

      var options = this.options;

      if (isArray(options)) {
        return options
      }

      return Object.keys(options).map(function (id) {
        var option = (isObject(options[id]) ? options[id] : ( obj = {}, obj[this$1.displayKey] = options[id], obj ));
        var obj;

        option[this$1.valueKey] = id;

        return option
      })
    }
  },

  methods: {

    getValue: function getValue (option) {
      return option[this.valueKey]
    },

    getDisplay: function getDisplay (option) {
      return option[this.displayKey]
    },

    getDisabled: function getDisabled (option) {
      return this.disabledKey.charAt(0) === '!' ? !option[this.disabledKey.substring(1)] : option[this.disabledKey]
    }

  },

  mixins: [inputHelper]
};

var InputText = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('input',_vm._b({staticClass:"form-control",attrs:{"id":_vm.id,"type":"text"},on:{"input":function($event){_vm.$emit('input', $event.target.value);}}},'input',{ value: _vm.value, required: _vm.required, autofocus: _vm.autofocus, placeholder: _vm.placeholder })),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()])},staticRenderFns: [],
  name: 'InputText',

  mixins: [inputHelper]
};

var TypeaheadField = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('dropdown',_vm._b({staticClass:"typeahead",on:{"select":_vm.onItemSelected}},'dropdown',{ items: _vm.items, show: _vm.show, component: _vm.component, itemKey: _vm.suggestionValue }),[_c('search-field',_vm._b({on:{"input":function (val) { return _vm.$emit('input', val); },"focus":function($event){_vm.show = true;},"blur":_vm.onBlur}},'search-field',{ value: _vm.value, placeholder: _vm.placeholder, suggestion: _vm.suggestion }),[_vm._t("default")],2),_c('div',{staticClass:"px-3 text-muted",slot:"empty"},[_vm._v("No results :(")])],1)},staticRenderFns: [],
  props: Object.assign({}, {suggestions: {
      type: Array,
      required: true
    },

    suggestionValue: {
      type: String,
      default: 'name'
    },

    search: {
      type: [Object, Array]
    },

    filter: {
      type: Function,
      default: function () { return true; }
    },

    component: {
      type: String
    }},

    mapObject(SearchField.props, ['value', 'placeholder'])),

  data: function data () {
    return {
      show: false
    }
  },

  computed: {
    indexed: function indexed () {
      return new Sifter(this.suggestions)
    },

    config: function config () {
      var search = this.search;
      var key = this.suggestionValue;

      var config = {
        fields: [key],
        sort: [key],
        limit: 25,
        empty_sort: [{ field: key, direction: 'asc' }]
      };

      if (isArray(search)) {
        config.fields = search;

        return config
      }

      if (isObject(search)) {
        return Object.assign({}, config, search)
      }

      return config
    },

    items: function items () {
      var this$1 = this;

      var indexed = this.indexed;
      var config = this.config;
      var value = this.value;

      var results = indexed.search(value, config);

      return results.items.map(function (ref) {
        var id = ref.id;

        return this$1.suggestions[id];
      }).filter(this.filter)
    },

    suggestion: function suggestion () {
      var suggestions = this.items;
      var value = this.value;
      var key = this.suggestionValue;

      var suggestion = suggestions.find(function (suggestion) { return typeof (suggestion[key]) === 'string' && suggestion[key].startsWith(value); });

      if (suggestion) { return suggestion[key] }

      return ''
    }
  },

  methods: {
    onItemSelected: function onItemSelected (item) {
      this.$emit('select', item);
    },

    onBlur: debounce(function onBlur () {
      this.show = false;

      this.$emit('blur');
    }, 100)
  },

  components: { Dropdown: Dropdown, SearchField: SearchField }
};

var InputTypeahead = {render: function(){var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',{staticClass:"form-group",class:{ 'has-danger': _vm.feedback }},[(_vm.title)?_c('label',{staticClass:"form-control-label",attrs:{"for":_vm.id}},[_vm._t("default",[_vm._v(_vm._s(_vm.title))])],2):_vm._e(),_c('typeahead-field',_vm._b({directives:[{name:"model",rawName:"v-model",value:(_vm.query),expression:"query"}],attrs:{"id":_vm.id},domProps:{"value":(_vm.query)},on:{"select":_vm.onSelect,"blur":_vm.onBlur,"input":function($event){_vm.query=$event;}}},'typeahead-field',{ required: _vm.required, autofocus: _vm.autofocus, suggestions: _vm.suggestions, suggestionKey: _vm.suggestionKey, search: _vm.search, filter: _vm.filter, component: _vm.component }),[_c('input',{staticClass:"input-search-placeholder-proxy",attrs:{"type":"text","readonly":"readonly"},domProps:{"value":_vm.placeholder}})]),(_vm.feedback)?_c('div',{staticClass:"form-control-feedback"},[_vm._v(_vm._s(_vm.feedback))]):_vm._e(),(_vm.subtitle)?_c('small',{staticClass:"form-text text-muted"},[_vm._t("subtitle",[_vm._v(_vm._s(_vm.subtitle))])],2):_vm._e()],1)},staticRenderFns: [],
  name: 'InputTypeahead',

  props: Object.assign({}, {suggestionKey: {
      type: String,
      default: 'id'
    }},

    mapObject(TypeaheadField.props, [
      'suggestions', 'suggestionValue', 'search', 'filter', 'component'
    ])),

  data: function data () {
    return {
      query: ''
    }
  },

  methods: {
    onBlur: function onBlur () {
      if (this.query === '') {
        this.$emit('input', '');
      } else {
        var current = this.findItemByValue(this.query);
        var item = this.findItem(this.value);

        if (current) {
          this.$emit('input', current[this.suggestionKey]);
        } else if (item) {
          this.query = item[this.suggestionValue];
        } else {
          this.query = '';
        }
      }
    },
    onSelect: function onSelect (item) {
      this.$emit('input', item[this.suggestionKey]);
    },
    findItem: function findItem (value) {
      var this$1 = this;

      return this.suggestions.find(function (suggestion) { return suggestion[this$1.suggestionKey] === value; })
    },
    findItemByValue: function findItemByValue (value) {
      var this$1 = this;

      return this.suggestions.find(function (suggestion) { return suggestion[this$1.suggestionValue] === value; })
    }
  },

  watch: {
    value: function value (value$1) {
      var item = this.findItem(value$1);

      if (item) {
        this.query = item[this.suggestionValue];
      }
    }
  },

  components: { TypeaheadField: TypeaheadField },
  mixins: [inputHelper]
};

var INPUT = {
  InputBox: InputBox, // Checkbox & Radio
  InputButton: InputButton, // Button
  InputSearch: InputSearch,
  InputSelect: InputSelect, // Select
  InputText: InputText, // Text, Number etc.
  InputTypeahead: InputTypeahead
};

var components = {
  Alert: Alert,
  Breadcrumb: Breadcrumb,
  CheckboxWrapper: CheckboxWrapper, // Wrapper for Box
  Dropdown: Dropdown,
  Icon: Icon,
  Search: SearchField,
  Typeahead: TypeaheadField
};

function each (obj, callback) {
  Object.keys(obj).forEach(function (key) { return callback(obj[key], key); });
}

function plugin (Vue, options) {
  if ( options === void 0 ) options = {};

  each(INPUT, function (component, name) { return Vue.component(name, component); });
}

// Install by default if using the script tag
if (typeof window !== 'undefined' && window.Vue) {
  window.Vue.use(plugin);
}

exports.INPUT = INPUT;
exports.components = components;
exports['default'] = plugin;

Object.defineProperty(exports, '__esModule', { value: true });

})));
